///home/berryj/link/bin/genMethods "-g" "-t" "DHyperGraph" "-r" "MDHyperGraph" "-I" "LINK/graph/DHyperGraph.h" "-y" "display_graph" "-w" "free_graph" "-d" "graph" "-f" "__dHyperGraph" 
#include <stk.h>
#include <LINK/stkWrapper/LINK_STk.h>

#include <LINK/graph/DHyperGraph.h>

#include <LINK/stkWrapper/Wrapper.h>
#include <LINK/stkWrapper/Register.h>

void display_graph(SCM, SCM, int);
void free_graph(SCM);

typedef DHyperGraph _DHyperGraph;

#define _DHyperGraphDATA(x) ((DHyperGraph*) (EXTDATA(x)))
#define _DHyperGraphIS_DATA(x) (TYPEP(x, tc_CXXwrapper) && \
		TYPEP(STk_slot_ref(x,val_scm), tc_CXXwrapper) && \
		(EXTID(STk_slot_ref(x,val_scm)) == Wrapper<DHyperGraph >::type))
#define _DHyperGraphISNT_DATA(x) (!_DHyperGraphIS_DATA(x))

#define _DHyperGraphCXX_DATA(x) (*(DHyperGraph*) (EXTDATA(VAL(x))))
#define _DHyperGraphCXX_IS_DATA(x) (INSTANCEP(x) && \
		TYPEP(STk_slot_ref(x,val_scm), tc_CXXwrapper) && \
		(EXTID(STk_slot_ref(x,val_scm)) == Wrapper<DHyperGraph >::type))
#define _DHyperGraphCXX_ISNT_DATA(x) (!_DHyperGraphCXX_IS_DATA(x))


PRIMITIVE STk_init___dHyperGraph()
{
	Wrapper<_DHyperGraph>::type = STk_new_CXXwrapper_id(
			Wrapper<_DHyperGraph>::name, 
			Wrapper<MDHyperGraph >::name,
			(void (*)(SCM x, SCM port, int mode))
			display_graph,
			(void (*)(SCM x))0,
			(void (*)(SCM x))free_graph);
	Tcl_InitHashTable(&Register<_DHyperGraph>::objTable, TCL_ONE_WORD_KEYS);
	return UNDEFINED;
}

void genExtra__dHyperGraphMethods(void);

PRIMITIVE STk_init_methods___dHyperGraph()
{
	genExtra__dHyperGraphMethods();
	return UNDEFINED;
}
